small_graphs = {'hole-mesh','minnesota',...
    'Pothen_commanche_dual','netscience-cc','power','hep-th-cc','rand-hyper-4000'};

results = [];
for gi=1:length(small_graphs)
    g = small_graphs{gi};
    A = readSMAT(sprintf('../../data/%s.smat',g));
    cents = centralities(A);
    
    for ci=1:length(cents)
        cents(ci)

        % We want each cluster to have about 30% of the graph
        maxvol = 0.3;
        H = hypercluster(A,'maxvol',maxvol/6,...
            'centrality',full(cents(ci).c));

        %% Compute the containment
        C = containment(A,H,'alpha',0.99,'method','leavetime','maxsteps',150);

        %% Combine clusters
        S = combine_clusters(A,C,'maxvol',maxvol,'coretype','best');

        %%
        % evaluate
        stats = overlapping_evaluation(A,S,700)

        results(end+1).cent = cents(ci);
        results(end).gi = gi;
        results(end).ci = ci;
        results(end).graph = g;
        results(end).name = cents(ci).name;
        results(end).eval = stats;
        results(end).rho = stats.rho;
    end
end
    

%% Accumulate results

C = full(sparse([results.gi],[results.ci],[results.rho]));

%
Cn = diag(1./sum(C,2))*C;

% show the summed normalized performance of each method
sum(Cn)

%% Display the results
