function S = cycle_overlap(nverts,nclusters)
% CYCLE_OVERLAP Produce the optimal overlapping clustering of a cycle graph


nclusters = floor(nclusters/2);
% allocate the matrix an entry at a time
nzi = zeros(2*nverts,1);
nzj = nzi;
curnz = 1;

c1 = 1;
for i=1:nclusters
    % compute the size of cluster i
    si = floor(nverts/nclusters) + double(i<=mod(nverts,nclusters)); 
    %Here's what we want to do ... S1(i,c1:(c1+si-1)) = -1;
    range = curnz:curnz+si-1;
    nzi(range) = i;
    nzj(range) = c1:(c1+si-1);
    c1 = c1+si;
    curnz = curnz+si;
end
% compute 1+half the vertices in the first set
c1 = 1 + floor((floor(nverts/nclusters) + double(i<=mod(nverts,nclusters)))/2);
% Here is what we want to do: S1(2*nclusters,1:c1-1) = -1;
range = curnz:curnz+c1-2;
nzi(range) = 2*nclusters;
nzj(range) = 1:c1-1;
curnz = curnz + c1-1;
for i=1:nclusters-1
    % compute the size of cluster i
    si = floor(nverts/nclusters) + double(i<=mod(nverts,nclusters));
    % Same deal ... S1(nclusters+i,c1:(c1+si-1)) = -1;
    range = curnz:curnz+si-1;
    nzi(range) = nclusters+i;
    nzj(range) = c1:(c1+si-1);
    c1 = c1+si;
    curnz = curnz+si;
end
% assign the final cluster
% Same deal ... S1(2*nclusters,c1:end) = -1;
range = curnz:curnz+(nverts-c1);
nzi(range) = 2*nclusters;
nzj(range) = c1:nverts;
S1 = sparse(nzi,nzj,1,2*nclusters,nverts);


% assign cores
nzi = zeros(nverts,1);
nzj = nzi;
curnz = 1;
c1 = 1 + floor(nnz(S1(1,:))/4);
% S1(end,1:c1-1) = 1;
range = curnz:curnz+c1-2;
nzi(range) = 2*nclusters;
nzj(range) = 1:c1-1;
curnz = curnz + c1-1;
cluster_num = 1;
for i=1:2*nclusters-1
    % compute the size of cluster i
    % a bit tricky 
    si = floor(nverts/(2*nclusters)) + double(cluster_num<=mod(nverts,2*nclusters));
    % S1(cluster_num,c1:(c1+si-1)) = 1;
    range = curnz:curnz+si-1;
    nzi(range) = cluster_num;
    nzj(range) = c1:(c1+si-1);
    curnz = curnz+si;
    cluster_num = cluster_num + nclusters;
    if cluster_num>2*nclusters, cluster_num = cluster_num +1 -2*nclusters; end;
    c1 = c1+si;
end
range = curnz:curnz+(nverts-c1);
nzi(range) = 2*nclusters;
nzj(range) = c1:nverts;

S2 = sparse(nzi,nzj,1,2*nclusters,nverts);
S = 2*S2 - S1; % a fancy expression to take 1 in S2 => 1 in S, and 1 in S1 => -1
%S = S2;