function S = cycle_partition(nverts,nclusters)
% CYCLE_PARTITION Produce the optimal partitioning of a cycle graph

% allocate the matrix an entry at a time
nzi = zeros(nverts,1);
nzj = nzi;
curnz = 1;

c1 = 1;
for i=1:nclusters
    % compute the size of cluster i
    si = floor(nverts/nclusters) + double(i<=mod(nverts,nclusters)); 
    %Here's what we want to do ... S1(i,c1:(c1+si-1)) = -1;
    range = curnz:curnz+si-1;
    nzi(range) = i;
    nzj(range) = c1:(c1+si-1);
    c1 = c1+si;
    curnz = curnz+si;
end
S = sparse(nzi,nzj,1,nclusters,nverts);

