%% Plot statistics on partitions of the cycle using our algorithm

%% 
addpath('../../matlab');

%%
ns = [2000,5000,10000,20000];

%%
results = [];
for ni = 1:length(ns)
    n = ns(ni);
    
    [A,xy] = cycle_graph(n);
    H = hypercluster(A,'maxvol',0.05);
    C = containment(A,H);
    S = combine_clusters(A,C,'maxvol',0.1);
    
    SO = cycle_overlap(n,size(S,1));
    SP = cycle_partition(n,size(S,1));
    
    results(end+1).n = n;
    results(end).eval = overlapping_evaluation(A,S);
    results(end).evalO = overlapping_evaluation(A,SO);
    results(end).evalP = overlapping_evaluation(A,SP);
end    
    
%% Display results as a table
for i=1:length(results)
    r = results(i);
    fprintf('%6i  %4.2f %8.2e  %8.2e  %8.2e\n', ...
        r.n, r.eval.vol_ratio, r.eval.rho, ...
        r.evalO.rho, r.evalP.rho);
end
            
    
