%% Setup

figsetup;
set(0,'DefaultAxesFontSize',24);
set(0,'DefaultLineMarkerSize',6);

%% See evertything

stats = show_report('lcsh.smat-cc')

%% Pick an interesting one... 
% small5 is pretty intersting
mystats = stats(end-5);


figure(1);
clf;

semilogx(mystats.hclusterStats(:,1),mystats.hclusterStats(:,4),'bo');
hold on;
semilogx(mystats.coresStats(:,1),mystats.coresStats(:,4),'r.','MarkerSize',15);
hold off;
xlim([1,5e5]);
ylim([0,1]);
xlabel('Cluster Vertices');
ylabel('Conductance');
box off;
transfigure;
print(gcf,'conductance-size-lcsh.eps','-depsc2');

%%
% Show histogram of conductances

figure(2);
clf
hold on;
[nbefore,xbefore] = hist(mystats.hclusterStats(:,4),10);
[nafter,xafter] = hist(mystats.coresStats(:,4),10);
plot(xbefore,nbefore/sum(nbefore),'b-');
plot(xafter,nafter/sum(nafter),'r-');
xlim([0,.5])
ylim([0,.5])
xlabel('conductance');
ylabel('density');
transfigure;
print(gcf,'conductance-density-lcsh.eps','-depsc2');

