%% Setup

figsetup;
set(0,'DefaultAxesFontSize',30);
set(0,'DefaultLineMarkerSize',6);

%% See evertything

stats = show_report('lcsh.smat-cc')

%% Pick an interesting one... 
% small5 is pretty intersting
mystats = stats(end-5);


figure(1);
clf;

semilogx(mystats.hclusterStats(:,1),mystats.hclusterStats(:,4),'bo');
hold on;
semilogx(mystats.coresStats(:,1),mystats.coresStats(:,4),'r.','MarkerSize',15);
hold off;
xlim([1,5e5]);
ylim([0,1]);
xlabel('Cluster Vertices');
ylabel('Conductance');
box off;
transfigure;
print(gcf,'conductance-size-lcsh-small-5.eps','-depsc2');

%%
% med5
mystats = stats(end-10);


figure(1);
clf;

semilogx(mystats.hclusterStats(:,1),mystats.hclusterStats(:,4),'bo');
hold on;
semilogx(mystats.coresStats(:,1),mystats.coresStats(:,4),'r.','MarkerSize',15);
hold off;
xlim([1,5e5]);
ylim([0,1]);
xlabel('Cluster Vertices');
ylabel('Conductance');
box off;
transfigure;
print(gcf,'conductance-size-lcsh-med-5.eps','-depsc2');

%%
% big5
mystats = stats(end-15);


figure(1);
clf;

semilogx(mystats.hclusterStats(:,1),mystats.hclusterStats(:,4),'bo');
hold on;
semilogx(mystats.coresStats(:,1),mystats.coresStats(:,4),'r.','MarkerSize',15);
hold off;
xlim([1,5e5]);
ylim([0,1]);
xlabel('Cluster Vertices');
ylabel('Conductance');
box off;
transfigure;
print(gcf,'conductance-size-lcsh-big-5.eps','-depsc2');


