#!/usr/bin/env python

"""
part2cores.py
=============

Convert a graph partitioning into a overlapping cover smat cores file.

History
-------
:2010-02-04: Initial version
"""

__author__ = 'David F. Gleich'

import sys
import os

def usage():
    print """
    Usage: part2cores.py partfile [smatfile]
    If smatfile is not listed, then we append .cores to partfile
    e.g. graph.part.100 -> graph.part.100.cores
    """
    

def main():
    
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        usage();
        sys.exit(-1)
    partfilename = sys.argv[1]
    
    
    if len(sys.argv)>2:
        coresfilename = sys.argv[2]
    else:
        coresfilename = partfilename + ".cores"

    part = []
    partfile = open(partfilename,'rt')
    for line in partfile:
        part.append(int(line))
    partfile.close()
    
    # metis number's its clusters unlike it's vertices, from 0,num-1
    # bizarre
    nparts = max(part)+1
    
    corefile = open(coresfilename,'wt')
    corefile.write('%i %i %i\n'%(nparts,len(part),len(part)))
    # v is the vertex number, c is the cluster number
    for v,c in enumerate(part):
        corefile.write('%i %i 1\n'%(c,v))
    corefile.close()
    
if __name__ == '__main__':
    main()
