#!/bin/bash

graph=$1
methodext=$2
cluster_maxvol=$3
final_maxvol=$4
expand=$5
overlap=$6

tmpdir=.
if [ $# -gt 6 ]; then
  tmpdir=$7
fi

(time ../../overlap-clusters/bin/hypercluster \
    ../../data/$graph \
    -maxvol $cluster_maxvol -out $tmpdir/$graph$methodext.hcluster \
    -expand $expand -minsize 5 -maxcond 0.95 -overlap $overlap \
    -statsfile $graph$methodext.hcluster.stats ) \
  2> $tmpdir/$graph$methodext.hcluster.time > $tmpdir/$graph$methodext.hcluster.run 

../../overlap-clusters/bin/pagerank-containment \
  ../../data/$graph $tmpdir/$graph$methodext.hcluster \
  $tmpdir/$graph$methodext.leavetimes leavetime 0.99 150

(time ../../overlap-clusters/bin/cover-combine \
    ../../data/$graph $tmpdir/$graph$methodext.leavetimes \
    $final_maxvol $tmpdir/$graph$methodext.cores) \
  2> $tmpdir/$graph$methodext.cores.time >  $tmpdir/$graph$methodext.cores.run

rm $tmpdir/$graph$methodext.leavetimes

bash evaluate_overlap.sh $graph $methodext $tmpdir

