#!/bin/bash

graph=$1
methodext=$2
cluster_maxvol=$3
final_maxvol=$4
nrun=$5

tmpdir=.
if [ $# -gt 5 ]; then
  tmpdir=$6
fi

if [ $nrun -eq 1 ]; then
  program=../../overlap-clusters/cluster_metis.py
else
  program="../../overlap-clusters/hypercluster_metis.py --nruns $nrun"
fi

(time python $program --maxvol $cluster_maxvol \
    ../../data/$graph.graph \
    --out $tmpdir/$graph$methodext.hcluster) \
  2> $tmpdir/$graph$methodext.hcluster.time \
  > $tmpdir/$graph$methodext.hcluster.run

../../overlap-clusters/bin/pagerank-containment \
  ../../data/$graph $tmpdir/$graph$methodext.hcluster \
  $tmpdir/$graph$methodext.leavetimes leavetime 0.99 150

(time ../../overlap-clusters/bin/cover-combine \
    ../../data/$graph $tmpdir/$graph$methodext.leavetimes $final_maxvol \
    $tmpdir/$graph$methodext.cores) \
    2> $tmpdir/$graph$methodext.cores.time \
    >  $tmpdir/$graph$methodext.cores.run 

rm $tmpdir/$graph$methodext.leavetimes

bash evaluate_overlap.sh $graph $methodext $tmpdir
