%% Prepare a runtime report

% a graph with its vertices and edges
graphs = { {'email-Enron.smat-cc',33696,361622}
           {'soc-Slashdot0811.smat-sym',77360,1015667}
           {'dico.smat-sym-cc',111982,2750576}
           {'lcsh.smat-cc',144791,394186}
           {'web-Google.smat-sym-cc',855802,8582704}
           {'as-skitter.smat-cc',1694616,22188418}
           {'cit-Patents.smat-sym-cc',3764117,33023481} };
       
% graphs = { {'email-Enron.smat-cc',33696,361622}
%            {'soc-Slashdot0811.smat-sym',77360,1015667}
% };       
    
%%
metis_part = zeros(0,2);

small_cluster = zeros(0,2);
big_cluster = zeros(0,2);

core_combine = zeros(0,2);

for gdata = graphs'
    gdata = gdata{1}; % extract data
    gname = gdata{1};
    nvert = gdata{2};
    nedge = gdata{3};
    size_measure= nvert;
    stats = load_report(gname);
    for stat=stats(:)'
        method = stat.method;
        if ~isempty(strfind(method,'metis.part'))
            metis_part(end+1,:) = [size_measure,stat.hclusterTime];
        elseif ~isempty(strfind(method,'small.5'))
            small_cluster(end+1,:) = [size_measure,stat.hclusterTime];
            core_combine(end+1,:) = [size_measure,stat.coresTime];
        elseif ~isempty(strfind(method,'big.5'))
            big_cluster(end+1,:) = [size_measure,stat.hclusterTime];
            core_combine(end+1,:) = [size_measure,stat.coresTime];
        end
    end
end

%%
figsetup;
figure(1);
clf;
hold on;
plot(metis_part(:,1),metis_part(:,2),'rx','MarkerSize',15);
plot(small_cluster(:,1),small_cluster(:,2),'k.','MarkerSize',30);
plot(big_cluster(:,1),big_cluster(:,2),'bo','MarkerSize',15);
plot(core_combine(:,1),core_combine(:,2),'g+','MarkerSize',15);
hold off;
xlabel('Graph Vertices');
ylabel('Seconds');
set(gca,'XScale','log');
set(gca,'YScale','log');
legend('Metis partitioning','Small clusters','Big clusters','Combine clusters',...
    'Location','SouthEast');
legend boxoff;
%%
transfigure;
print(gcf,'runtime-fig.eps','-depsc2');