%% Test overlapping clusters with metis
setup_matlab_path
%%
[A,xy] = load_data('rand-hyper-4000');
maxvol = 0.1;
H = hypercluster_metis(A,'nruns',10,'maxvol',maxvol,'minvol',maxvol,'seed',-1);
sum(H(1,:))
C = containment(A,H,'alpha',0.99,'method','leavetime','maxsteps',150);
S = combine_clusters(A,C,'maxvol',maxvol,'coretype','best');
stats = overlapping_evaluation(A,S)

%%
% Plot the cores
clf; hold on; axis off;
[lx,ly]=gplot(A,xy); h=plot(lx,ly,'k-','LineWidth',0.5);
set(h,'Color',0.6*[1 1 1]); colormap(hot);
axis square;
[cs vs ignore] = find(S==1);
scatter(xy(vs,1),xy(vs,2),4,cs);
colormap(hot);
%%
% Show overlap
clf; hold on; axis off; set(gcf,'Color',0.8*[1,1,1]);
[lx,ly] = gplot(A,xy); 
plot(lx,ly,'Color',[0.7,0.7,0.7]);
axis square;
olap = sum(spones(S));
scatter(xy(:,1),xy(:,2),4,olap);
colormap(hot);
colorbar;
%% 
%Show individual clusters
clf; hold on; axis off; set(gcf,'Color',0.8*[1,1,1]);
[lx,ly] = gplot(A,xy); 
plot(lx,ly,'Color',[0.7,0.7,0.7]);
axis square;
ci = 40;
cv = S(ci,:);
scatter(xy(:,1),xy(:,2),4,cv);
colormap(hot);
h = colorbar;
set(h,'YTick',[-1,0,1]); set(h,'YTickLabel',{'In cluster','Out of cluster','In cluster core'});


