%% Commanche example
%% A big example
addpath('../../matlab');
filename = '../../data/Pothen_commanche_dual';
A = readSMAT([filename '.smat']);
xy = load([filename '.xyz']);
H = hypercluster(A,'maxvol',0.1);

%%
% Evaluate different types of containment
C = containment(A,H,'alpha',0.995,'method','leavetime','maxsteps',150);
clf; hold on;
[lx,ly]=gplot(A,xy); h=plot(lx,ly,'k-','LineWidth',0.5);
set(h,'Color',0.6*[1 1 1]); colormap(hot);
hi = 37;
    [i,hverts,probs] = find(C(hi,:));
    xys = xy(hverts,:);
    scatter(xys(:,1),xys(:,2),15,probs,'filled')
colorbar;

%%
% Fix a containment
C = containment(A,H,'alpha',0.995,'method','leavetime','maxsteps',150);
    
%% 
% Visualize the containment
clf; hold on;
[lx,ly]=gplot(A,xy); h=plot(lx,ly,'k-','LineWidth',0.5);
set(h,'Color',0.6*[1 1 1]); colormap(hot);
%plot(lx,ly,'k.','MarkerSize',5);
%set(gca,'XTick',[]); set(gca,'YTick',[]); box off;

axis square;

for hi=1:min(100,size(C,1))
    [i,hverts,probs] = find(C(hi,:));
    xys = xy(hverts,:);
    scatter(xys(:,1),xys(:,2),15,probs,'filled')
    %plot(xys(:,1), xys(:,2),'r.','MarkerSize',15);
end
colorbar;

%%
% Combine clusters
S = combine_clusters(A,C,'maxvol',0.1,'coretype','each','betascale',2.5,'border_penalty',50);
%%
% Plot the cores
clf; hold on;
[lx,ly]=gplot(A,xy); h=plot(lx,ly,'k-','LineWidth',0.5);
set(h,'Color',0.6*[1 1 1]); colormap(hot);
axis square;
[cs vs ignore] = find(S==1);
scatter(xy(vs,1),xy(vs,2),4,cs);
%% 
% Show individual clusters
clf; 
%[lx,ly] = gplot(A,xy); 
%plot(lx,ly,'Color',[0.7,0.7,0.7]);

ci = 3;
cv = S(ci,:);
olap = sum(spones(S));
scatter3(xy(:,1),xy(:,2),xy(:,3),4,cv);
colormap(hot);axis off;
colorbar;

%%
%Show overlap
clf; hold on; axis off;
[lx,ly] = gplot(A,xy); 
plot(lx,ly,'Color',[0.7,0.7,0.7]);

olap = sum(spones(S));
scatter(xy(:,1),xy(:,2),4,olap);
colormap(hot);
colorbar;
