%%
addpath('../tools'); % for export fig
addpath('../../matlab'); % for readSMAT

%%
filename = '../../data/randgeom-square-1000';
A = readSMAT([filename '.smat']);
xy = load([filename '.xy']);

%% 
H = hypercluster(A,'maxvol',1000);

%% 
% Show a few clusters
clf; hold on;
[lx,ly]=gplot(A,xy); plot(lx,ly,'b-','LineWidth',0.5);
plot(lx,ly,'k.','MarkerSize',5);
%set(gca,'XTick',[]); set(gca,'YTick',[]); box off;
set(gcf,'Color','none');
set(gca,'Color','none');
axis off;

for hi=1:10
    hverts = find(H(hi,:));
    xys = xy(hverts,:);
    k = convhull(xys(:,1),xys(:,2)); 
    p=patch(xys(k,1),xys(k,2),[0.5,0.5,0.5]);
    set(p,'FaceAlpha',0.7);
    plot(xys(:,1),xys(:,2),'r.','MarkerSize',16);
end

%%
% Score and combine
C = containment(A,H);
[S,coremap] = combine_clusters(A,C,'maxvol',1000);

%% 
% Show clusters and cores
clf; hold on;
[lx,ly]=gplot(A,xy); plot(lx,ly,'b-','LineWidth',0.5);
plot(lx,ly,'k.','MarkerSize',5);
set(gcf,'Color','none');
set(gca,'Color','none');
axis off;

ci = 1;
hverts = find(S(hi,:));
xys = xy(hverts,:);
plot(xys(:,1),xys(:,2),'k.','MarkerSize',15);
corefilt = coremap==ci;
plot(xy(corefilt,1),xy(corefilt,2),'r.','MarkerSize',15);



