%% Test out pagerank algorithms in overlapping clusters

A = load_data('tapir');
n = size(A,1);
[i,j] = find(A);
d = accumarray(i,1);
P = sparse(i,j,1./d(i),n,n);


%%
alpha = 0.85;
x = (speye(n) - alpha*P')\ones(n,1);
y = x./norm(x,1);

%% test code in one cluster
C = ones(1,1024);
z = pagerank_in_clusters(A,C,alpha);
zn = z./norm(z,1);
norm(y-zn)
plot(x,z,'.');

%% 
% test code in two clusters
C = [ones(1,512),zeros(1,512);
     zeros(1,512),ones(1,512)];
z = pagerank_in_clusters(A,C,alpha);
zn = z./norm(z,1);
norm(y-zn)
plot(x,z,'.');

%% 
% test code in two clusters with overlap
C = [ones(1,512) -ones(1,256) zeros(1,256);
     zeros(1,256) -ones(1,256) ones(1,512)];
z = pagerank_in_clusters(A,C,alpha);
zn = z./norm(z,1);
norm(y-zn)
plot(x,z,'.');
 