%% Try different parameter tweaking to see what it changes.


%A = spones(load_data('cond-mat-2005-fix-cc'));
A = spones(load_data('email-Enron'));

final_maxvol = 1/10;

%% compute the metis solution
H = hypercluster_metis(A,'maxvol',final_maxvol,'nruns',1);
C = containment(A,H,'alpha',0.99,'method','leavetime','maxsteps',150);
S = combine_clusters(A,C,'maxvol',final_maxvol,'coretype','best');
metis_stats = overlapping_evaluation(A,S);

%% play with our solutions
noverlap = [1 2 5 10 30 100000];
nrep = 2;
results_vol = zeros(length(noverlap),nrep);
results_rho = results_vol;
results_comm = results_vol;
hcluster_maxvol = 10000;
expand = 1;
figure;
for noverlapi=1:length(noverlap)
    for repi = 1:nrep        
        H = hypercluster(A,'seed',-1,'maxvol',hcluster_maxvol,...
            'overlap',noverlap(noverlapi),'expand',expand,'maxcond',0.95,'minsize',5);
        C = containment(A,H,'alpha',0.99,'method','leavetime','maxsteps',150);
        S = combine_clusters(A,C,'maxvol',final_maxvol,'coretype','best');
        
        stats = overlapping_evaluation(A,S);
        
        results_vol(noverlapi,repi) = stats.vol_ratio;
        results_rho(noverlapi,repi) = stats.rho;
        results_comm(noverlapi,repi) = stats.pagerank_communication;
        
        subplot(1,2,1);
        plot(results_vol(:),results_rho(:),'.');
        line(xlim,metis_stats.rho*[1,1]);
        xlabel('Vol Ratio');
        ylabel('Rho');
        
        subplot(1,2,2);
        plot(results_vol(:),results_comm(:),'.');
        line(xlim,metis_stats.pagerank_communication*[1,1]);
        xlabel('Vol Ratio');
        ylabel('Communication');
        drawnow;
        
        
        
    end
end