#include <random>
#include <iostream>

#include <random>

#if defined(_WIN32) || defined(_WIN64)
#define tr1ns std::tr1
#else
#define tr1ns std
#endif

tr1ns::mt19937 sparfun_rand;

typedef tr1ns::mt19937                                        generator_t;
typedef tr1ns::uniform_real<double>                           distribution_t;
typedef tr1ns::variate_generator<generator_t, distribution_t> variate_t;
variate_t sparfun_rand_unif(sparfun_rand, distribution_t(0.0, 1.0));


void sf_srand(unsigned long seed)
{
  sparfun_rand.seed(seed);
  sparfun_rand_unif = variate_t(sparfun_rand, distribution_t(0.0, 1.0));
}

double sf_rand(double min, double max)
{
  tr1ns::uniform_real<double> dist(min,max);
  return dist(sparfun_rand_unif);
}

int sf_randint(int min, int max)
{
  tr1ns::uniform_int<int> dist(min,max);
  return dist(sparfun_rand_unif);
}


int main(int argc, char **argv) 
{
    sf_srand(0);
    for (int i=0; i<10; ++i) std::cout << sf_randint(0,10) << std::endl; 
    for (int i=0; i<10; ++i) std::cout << sf_rand(0.,1.) << std::endl; 
    sf_srand(0);
    for (int i=0; i<10; ++i) std::cout << sf_randint(0,10) << std::endl; 
    for (int i=0; i<10; ++i) std::cout << sf_rand(0.,1.) << std::endl; 
    
}
