function S=expnum2latex(num,format)
% Convert a number into latex, but using a exponetial format e.g. 1 x 10^{5}
if ~exist('format','var'), format = '%8.2e'; end
S = sprintf(format,num);
S = ['$' S '$'];

% the following is from Tobin Driscoll's latex.m function
S = strrep(S,'e','E');
ex = min(findstr(S,'E'));
while ~isempty(ex)
  % Find first non-digit character. Where is ISDIGIT?
  j = ex+2;
  while j<=length(S) && ~isempty(str2num(S(j))) && ~strcmp(S(j),'i')
    j = j+1;
  end

  % This strips off leading '+' and zeros.
  num = sprintf('%i',str2num(S(ex+1:j-1)));
  
  ee = ['\times 10^{' num '}'];
  S = [S(1:ex-1) ee S(j:end)];
  
  ex = ex + min(findstr(S(ex+1:end),'E'));
end

