function H = partition_to_clustering(p)
% PARTITION_TO_CLUSTERING Convert a partition vector to a clustering
% H = partition_to_clustering(p) 
% returns a matrix H(i,j) with H(i,j) = 1 if vertex j is in cluster i.
% the input is a partition vector p with p(j)=i if vertex j is in cluter i.
% the matrix can encode overlapping clusters whereas the vector cannot.

H = sparse(length(p),0);
uniqclusters = unique(p);
numclusters = length(uniqclusters);
for c=1:numclusters
    ci = uniqclusters(c);
    H(:,end+1) = sparse((p == ci)');
end
H = H';