/**
 * @file containment.h
 * Utility functions for the sparse matrix function library
 */


/** 
 * @author  David F. Gleich
 * Copyright 2008-2010, Various
 *
 * History
 * --------
 * :2010-02-05: Initial coding
 */
 
#include "sparfun.h"

void compute_leavetimes(
      sparserow *G, int *group, int groupsize, 
      double alpha, double tol, int maxiter,
      int *iwork, double *dwork,
      double *leavetimes);
      
void compute_escaping_probabilities(
      sparserow *G, int *group, int groupsize, 
      double alpha, double tol, int maxiter,
      int *iwork, double *dwork,
      double *probs);
